



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS开发数据库篇—FMDB简单介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS开发数据库篇—FMDB简单介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:33:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>iOS开发数据库篇&mdash;FMDB简单介绍</strong></p>
<p><strong>一、简单说明</strong></p>
<p>1.什么是FMDB</p>
<p>FMDB是iOS平台的SQLite数据库框架</p>
<p>FMDB以OC的方式封装了SQLite的C语言API</p>
<p>2.FMDB的优点</p>
<p>使用起来更加面向对象，省去了很多麻烦、冗余的C语言代码</p>
<p>对比苹果自带的Core Data框架，更加轻量级和灵活</p>
<p>提供了多线程安全的数据库操作方法，有效地防止数据混乱</p>
<p>3.FMDB的github地址</p>
<p>https://github.com/ccgus/fmdb</p>
<p><strong>二、核心类</strong></p>
<p>FMDB有三个主要的类</p>
<p>（1）FMDatabase</p>
<p>一个FMDatabase对象就代表一个单独的SQLite数据库</p>
<p>用来执行SQL语句</p>
<p>（2）FMResultSet</p>
<p>使用FMDatabase执行查询后的结果集</p>
<p>（3）FMDatabaseQueue</p>
<p>用于在多线程中执行多个查询或更新，它是线程安全的</p>
<p><strong>三、打开数据库</strong></p>
<p>通过指定SQLite数据库文件路径来创建FMDatabase对象</p>
<p>FMDatabase *db = [FMDatabase databaseWithPath:path];</p>
<p>if (![db open]) {</p>
<p>NSLog(@"数据库打开失败！");</p>
<p>}</p>
<p>文件路径有三种情况</p>
<p>（1）具体文件路径</p>
<p>　　如果不存在会自动创建</p>
<p>（2）空字符串@""</p>
<p>　　会在临时目录创建一个空的数据库</p>
<p>　　当FMDatabase连接关闭时，数据库文件也被删除</p>
<p>（3）nil</p>
<p>　　会创建一个内存中临时数据库，当FMDatabase连接关闭时，数据库会被销毁</p>
<p><strong>四、执行更新</strong></p>
<p>在FMDB中，除查询以外的所有操作，都称为&ldquo;更新&rdquo;</p>
<p>create、drop、insert、update、delete等</p>
<p>使用executeUpdate:方法执行更新</p>
<p>- (BOOL)executeUpdate:(NSString*)sql, ...</p>
<p>- (BOOL)executeUpdateWithFormat:(NSString*)format, ...</p>
<p>- (BOOL)executeUpdate:(NSString*)sql withArgumentsInArray:(NSArray *)arguments</p>
<p>示例</p>
<p>[db executeUpdate:@"UPDATE t_student SET age = ? WHERE name = ?;", @20, @"Jack"]</p>
<p><strong>五、执行查询</strong></p>
<p>查询方法</p>
<p>- (FMResultSet *)executeQuery:(NSString*)sql, ...</p>
<p>- (FMResultSet *)executeQueryWithFormat:(NSString*)format, ...</p>
<p>- (FMResultSet *)executeQuery:(NSString *)sql withArgumentsInArray:(NSArray *)arguments</p>
<p>示例</p>
<p>// 查询数据</p>
<p>FMResultSet *rs = [db executeQuery:@"SELECT * FROM t_student"];</p>
<p>// 遍历结果集</p>
<p>while ([rs next]) {</p>
<p>NSString *name = [rs stringForColumn:@"name"];</p>
<p>int age = [rs intForColumn:@"age"];</p>
<p>double score = [rs doubleForColumn:@"score"];</p>
<p>}</p>
<p><strong>六、代码示例</strong></p>
<p>1.新建一个项目，导入libsqlite3库，并在项目中包含主头文件</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/450136/201407/272008173076623.png" /></p>
<p>2.下载第三方框架FMDB</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/450136/201407/272008562448395.png" /></p>
<p>3.示例代码</p>
<p>　　YYViewController.m文件</p>
<div>
<pre class="prettyprint linenums"> //<br />
 //  YYViewController.m<br />
 //  04-FMDB基本使用<br />
 //<br />
 //  Created by apple on 14-7-27.<br />
 //  Copyright (c) 2014年 wendingding. All rights reserved.<br />
 //

 #import "YYViewController.h"<br />
 #import "FMDB.h"

 @interface YYViewController ()<br />
 @property(nonatomic,strong)FMDatabase *db;<br />
 @end

 @implementation YYViewController

 - (void)viewDidLoad<br />
 {<br />
     [super viewDidLoad];<br />
     //1.获得数据库文件的路径<br />
     NSString *doc=[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];<br />
     NSString *fileName=[doc stringByAppendingPathComponent:@"student.sqlite"];

     //2.获得数据库<br />
     FMDatabase *db=[FMDatabase databaseWithPath:fileName];

     //3.打开数据库<br />
     if ([db open]) {<br />
         //4.创表<br />
         BOOL result=[db executeUpdate:@"CREATE TABLE IF NOT EXISTS t_student (id integer PRIMARY KEY AUTOINCREMENT, name text NOT NULL, age integer NOT NULL);"];<br />
         if (result) {<br />
             NSLog(@"创表成功");<br />
         }else<br />
         {<br />
             NSLog(@"创表失败");<br />
         }<br />
     }<br />
     self.db=db;

 }

 -(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event<br />
 {<br />
     [self delete];<br />
     [self insert];<br />
     [self query];<br />
 }

 //插入数据<br />
 -(void)insert<br />
 {<br />
     for (int i = ; i&lt;; i++) {<br />
         NSString *name = [NSString stringWithFormat:@"jack-%d", arc4random_uniform()];<br />
         // executeUpdate : 不确定的参数用?来占位<br />
         [self.db executeUpdate:@"INSERT INTO t_student (name, age) VALUES (?, ?);", name, @(arc4random_uniform())];<br />
         //        [self.db executeUpdate:@"INSERT INTO t_student (name, age) VALUES (?, ?);" withArgumentsInArray:@[name, @(arc4random_uniform(40))]];

         // executeUpdateWithFormat : 不确定的参数用%@、%d等来占位<br />
         //        [self.db executeUpdateWithFormat:@"INSERT INTO t_student (name, age) VALUES (%@, %d);", name, arc4random_uniform(40)];<br />
     }<br />
 }

 //删除数据<br />
 -(void)delete<br />
 {<br />
     //    [self.db executeUpdate:@"DELETE FROM t_student;"];<br />
     [self.db executeUpdate:@"DROP TABLE IF EXISTS t_student;"];<br />
     [self.db executeUpdate:@"CREATE TABLE IF NOT EXISTS t_student (id integer PRIMARY KEY AUTOINCREMENT, name text NOT NULL, age integer NOT NULL);"];<br />
 }

 //查询<br />
 - (void)query<br />
 {<br />
     // 1.执行查询语句<br />
     FMResultSet *resultSet = [self.db executeQuery:@"SELECT * FROM t_student"];

     // 2.遍历结果<br />
     while ([resultSet next]) {<br />
         int ID = [resultSet intForColumn:@"id"];<br />
         NSString *name = [resultSet stringForColumn:@"name"];<br />
         int age = [resultSet intForColumn:@"age"];<br />
         NSLog(@"%d %@ %d", ID, name, age);<br />
     }<br />
 }

 @end</pre>
</div>
<p>打印查看结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/450136/201407/272018261824042.png" /></p>
<p>提示：</p>
<p>如果ID设置为逐渐，且设置为自动增长的话，那么把表中的数据删除后，重新插入新的数据，ID的编号不是从0开始，而是接着之前的ID进行编号。</p>
<p>注意：</p>
<p>　　不要写成下面的形式，不要加''，直接使用%@,它会自动认为这是一个字符串。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/450136/201407/272023350728341.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvvoeyq.html">Android App的设计架构：MVC&comma;MVP&comma;MVVM与架构经验谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8me166q.html">mas&lowbar;makeConstraints &amp;amp&semi;&amp;amp&semi; mas&lowbar;remakeConstraints &amp;amp&semi;&amp;amp&semi; mas&lowbar;updateConstraints 用法与注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqly5yk9.html">尖刀出鞘的display常用属性及css盒模型深入研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok6dze9.html">flex中validateall&lpar;&rpar;方法， 多Item验证 ，结果统一提示</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4w5lq.html">『电脑技巧』浅谈Win7的文件共享设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjjr3x8.html">smb&lowbar;精简安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwnd49.html">网络资源&lpar;9&rpar; - TDD视频</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2j1e8.html">node-webkit学习之【无边框窗口用JS实现拖动改变大小等】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd243y9.html">将传统项目改造为SSM框架的项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg56rq.html">Git常用的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvly4k8.html">强化学习（三）&mdash;&mdash; 时序差分法（SARSA和Q-Learning）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rp6v39.html">Intellij 高亮显示与选中字符串相同的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2orrj9.html">VSCode 拓展插件推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2115pq.html">Python3下获取WINDOWS下所有常用系统路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kopwy3q.html">linphone</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmdxpw9.html">C&plus;&plus;可继承的单例基类模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk5ozn8.html">Atitit&period;各种  数据类型 &lpar; 树形结构&comma;表形数据  &rpar; 的结构与存储数据库 attilax  总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p075g8.html">javascript父、子页面交互小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xd5rv9.html">linxu系统压缩解压命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4yznr8.html">Linux内核堆栈使用方法 进程0和进程1【转】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9j76xl9.html">4&period;用PHP打印出前一天的时间格式是2006-5-10 22&colon;21&colon;21</a>
			</li>
						<li><a href="https://www.batexi.com/a/r931rlz8.html">Shell脚本关于屏幕输出的字符进行颜色控制的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96nn5vq.html">boost源码剖析----boost&colon;&colon;any</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8orr2x8.html">C&plus;&plus; 学习笔记（2） &mdash;&mdash; float 和 double 的精度</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwyy238.html">WDR7500 花生壳问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kzzx78.html">POJ - 1132Border</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p5o6k8.html">Java：String和Date、Timestamp之间的转</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy3zpm8.html">python学习之认识字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q21o138.html">Java Code Examples for  PhantomJSDriverService</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q714mxq.html">&lbrack;问题2014A03&rsqb; 复旦高等代数 I（14级）每周一题（第五教学周）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
